"use client";
import { usePathname } from "@/i18n";
import { useEffect } from "react";

const Scroll = () => {
    const scrollToTop = () => {
        const parentEle = document.querySelector("#maincontainer");
        parentEle!.scrollTo({ top: 0, behavior: "smooth" });
    };
    // 获取分享id
    const pathname = usePathname();
    useEffect(() => {
        const [, shareId] = pathname.split("/");
        if (!shareId || shareId === "xxxxxx") return;
        if (shareId.length !== 8) {
            sessionStorage.removeItem("shareId");
            return;
        }
        sessionStorage.setItem("shareId", shareId);
    }, []);
    return (
        <div className={"mt-[0.3rem] flex items-center justify-around pb-[0.5rem] text-[#fff]"}>
            <div
                className={
                    "h-[0.45rem] w-[0.45rem] rounded bg-gradient-to-b from-[#ff9323]" +
                    " flex items-center justify-center to-[#ff6a01]"
                }
            >
                <span className={"iconfont icon-shoucang text-[0.15rem]"}></span>
            </div>
            <div
                className={
                    "flex h-[0.46rem] w-[0.46rem] rounded-[0.02rem] bg-[#25272c]" +
                    " flex-col items-center justify-center text-[0.12rem]"
                }
                onClick={scrollToTop}
            >
                <span className={"iconfont icon-xiangshang text-[#ff6a01]"}></span>
                Top
            </div>
        </div>
    );
};

export default Scroll;
